/*
 * Copyright (c) 2007, 2008 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on Nov 30, 2009
 * Author: T. Rekawek <newton@mat.uni.torun.pl>
 */

package pl.edu.icm.unicore.uvos.db;

import java.util.concurrent.locks.ReentrantReadWriteLock;

/**
 * Wrapper for reentrant lock.
 * @author T. Rekawek
 */
public class DBLock
{
	private ReentrantReadWriteLock lock;
	
	public DBLock()
	{
		lock = new ReentrantReadWriteLock();
	}
	
	public void writeLock()
	{
		lock.writeLock().lock();
	}
	
	public void writeUnlock()
	{
		lock.writeLock().unlock();
	}
	
	public void readLock()
	{
		lock.readLock().lock();
	}
	
	public void readUnlock()
	{
		lock.readLock().unlock();
	}
}
