/*
 * Copyright (c) 2007, 2008 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on Mar 14, 2007
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */

package pl.edu.icm.unicore.uvos.engine;

import java.io.Serializable;

import pl.edu.icm.unicore.uvos.api.Identity;
import pl.edu.icm.unicore.uvos.model.EntityBean;

/**
 * Security context must be established prior any VO related API operation
 * It is used to retrieve cached identity data.
 * @author K. Benedyczak
 */
public interface SecurityContext extends Serializable
{
	/**
	 * @return the authenticated entity which is represented by this context.
	 */
	public Identity getCaller();
	
	/**
	 * @return the authenticated entity bean which is represented by this context or null
	 * if it is a virtual context not related to any DB object. 
	 */
	public EntityBean getEntity();
}
