/*
 * Copyright (c) 2007, 2008 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on Mar 18, 2007
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */

package pl.edu.icm.unicore.uvos.engine;

import pl.edu.icm.unicore.uvos.api.Identity;
import pl.edu.icm.unicore.uvos.model.EntityBean;

/**
 * Standard security token which is mapped onto EntityBeans 
 * in {@link VOAuthorizationModule}.
 * @author K. Benedyczak
 */
public class SecurityContextImpl implements SecurityContext
{
	private static final long serialVersionUID = -6392756119284609287L;
	private EntityBean entity;
	private Identity caller;

	public SecurityContextImpl(Identity caller, EntityBean eb)
	{
		this.caller = caller;
		this.entity = eb;
	}

	public Identity getCaller()
	{
		return caller;
	}
	
	public EntityBean getEntity()
	{
		return entity;
	}

	public boolean equals(Object o)
	{
		if (!(o instanceof SecurityContextImpl))
			return false;
		if (((SecurityContextImpl)o).getCaller().equals(caller))
			return true;
		return false;
	}

	public int hashCode(){
		if(caller==null) return 0;
		return 0x3546322^caller.hashCode();
	}
}
