/*
 * Copyright (c) 2007, 2008 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on Mar 18, 2007
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */

package pl.edu.icm.unicore.uvos.engine;

import pl.edu.icm.unicore.uvos.api.Identity;
import pl.edu.icm.unicore.uvos.api.IdentityType;
import pl.edu.icm.unicore.uvos.api.Permissions;
import pl.edu.icm.unicore.uvos.model.EntityBean;

/**
 * Security token which represents entity with fixed permissions. Used
 * by internal clients (i.e. modules using UVOS server as library).
 * <p>
 * Warning: with this security context it is impossible to receive "self access"
 * mode.
 * @author K. Benedyczak
 */
public class VirtualSecurityContextImpl implements SecurityContext
{
	private static final long serialVersionUID = 1306269905374355664L;
	private Permissions perms;
	private Identity caller;

	public VirtualSecurityContextImpl(Permissions perms)
	{
		super();
		this.perms = perms;
		caller = new Identity(new IdentityType("virtualIdentity"), "system access");
	}
	public Permissions getPerms()
	{
		return perms;
	}
	public void setPerms(Permissions perms)
	{
		this.perms = perms;
	}
	public Identity getCaller()
	{
		return caller;
	}
	public EntityBean getEntity()
	{
		return null;
	}
}
