/*
 * Copyright (c) 2007, 2008 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on Mar 13, 2007
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */

package pl.edu.icm.unicore.uvos.model;

/**
 * Attribute belongs to any of @link{GroupElement}. It has name, attribute type
 * and corresponding value. Attributes can be global or group-bound. Latter means
 * that it is valid only in scope of the group. E.g. Entity A with group-bound attribute
 * "Role=Admin", bound to group A, will have Admin Role only in group A (and it's parent groups).
 * Such group-bound attributes are "visible" only when asking for identity's attributes in 
 * scope of some group (or it's parent group when asking for effective attribute).
 * 
 * @author K. Benedyczak
 */
public class AttributeBean extends TSBean
{
	private int id;
	private String val;
	private int typeId;
	private int groupId;
	private int inactive;
	private int entityId;
	
	
	public int getEntityId()
	{
		return entityId;
	}
	public void setEntityId(int entityId)
	{
		this.entityId = entityId;
	}
	public int getInactive()
	{
		return inactive;
	}
	public void setInactive(int inactive)
	{
		this.inactive = inactive;
	}
	public int getGroupId()
	{
		return groupId;
	}
	public void setGroupId(int groupId)
	{
		this.groupId = groupId;
	}
	public int getId()
	{
		return id;
	}
	public void setId(int id)
	{
		this.id = id;
	}
	public int getTypeId()
	{
		return typeId;
	}
	public void setTypeId(int typeId)
	{
		this.typeId = typeId;
	}
	public String getVal()
	{
		return val;
	}
	public void setVal(String val)
	{
		this.val = val;
	}
}
