/*
 * Copyright (c) 2007, 2008 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on Mar 13, 2007
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */

package pl.edu.icm.unicore.uvos.model;

import java.io.Serializable;

/**
 * Entity is used to group set of @link{Identity identities} (minimally one) which are 
 * bound to one person/agent etc. Usually Entity holds only one id.
 * 
 * Entites are used as element of group (not bare Identities).
 * 
 * @author K. Benedyczak
 */
public class EntityBean extends GroupElementBean implements Serializable
{
	private static final long serialVersionUID = 4356797561681509014L;
	private String name;
	private String persistentId;
	private int id;

	public String getPersistentId()
	{
		return persistentId;
	}

	public void setPersistentId(String persistentId)
	{
		this.persistentId = persistentId;
	}

	public int getId()
	{
		return id;
	}

	public void setId(int id)
	{
		this.id = id;
	}

	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}
}
