/*
 * Copyright (c) 2007, 2008 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on Mar 13, 2007
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */

package pl.edu.icm.unicore.uvos.model;

/**
 * Group holds set of other elements, all are of the type {@link GroupElementBean}.
 *  
 * @author K. Benedyczak
 */
public class GroupBean extends GroupElementBean
{
	private int id;
	private String name;
	private Integer parent;
	
	public int getId()
	{
		return id;
	}
	public void setId(int id)
	{
		this.id = id;
	}
	public String getName()
	{
		return name;
	}
	public void setName(String name)
	{
		this.name = name;
	}
	public int getParent()
	{
		if (parent == null)
			return -1;
		return parent;
	}
	public void setParent(Integer parent)
	{
		this.parent = parent;
	}
	
	@Override
	public int hashCode()
	{
		final int prime = 31;
		int result = 1;
		result = prime * result + id;
		return result;
	}
	@Override
	public boolean equals(Object obj)
	{
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		GroupBean other = (GroupBean) obj;
		if (id != other.id)
			return false;
		return true;
	}
}
