/*
 * Copyright (c) 2011 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on 02-09-2011
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */
package pl.edu.icm.unicore.uvos.server;

import pl.edu.icm.unicore.uvos.util.GLUEInfoProvider;
import pl.edu.icm.unicore.uvos.wsapi.xmlbeans.CISInfoProvider;
import pl.edu.icm.unicore.uvos.wsapi.xmlbeans.UVOSFault;
import xmlbeans.pl.edu.icm.uvos.cisprovider.GetServiceInfoRequestDocument;
import xmlbeans.pl.edu.icm.uvos.cisprovider.GetServiceInfoResponseDocument;
import xmlbeans.pl.edu.icm.uvos.glue2.ServiceT;

/**
 * Implementation of the GLUE 2 query WS interface.
 * @author K. Benedyczak
 */
public class WSGLUEInfoProviderImpl implements CISInfoProvider
{
	private GLUEInfoProvider infoProvider;
	
	public WSGLUEInfoProviderImpl(GLUEInfoProvider infoProvider)
	{
		this.infoProvider = infoProvider;
	}

	@Override
	public GetServiceInfoResponseDocument getServiceInfo(
			GetServiceInfoRequestDocument req) throws UVOSFault
	{
		GetServiceInfoResponseDocument res = GetServiceInfoResponseDocument.Factory.newInstance();
		ServiceT[] arrServiceT = new ServiceT[] {infoProvider.getServiceDesc()};
		res.addNewGetServiceInfoResponse().setServiceArray(arrServiceT);
		return res;
	}
}
