/*
 * Copyright (c) 2007, 2008 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on Aug 17, 2007
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */

package pl.edu.icm.unicore.uvos.server.idresolver;

import eu.unicore.security.SecurityTokens;
import pl.edu.icm.unicore.uvos.api.Identity;
import pl.edu.icm.unicore.uvos.api.exceptions.UVOSException;
import pl.edu.icm.unicore.uvos.engine.SecurityContext;

/**
 * Resolves some sort of credentials into {@link Identity} and authenticates it.
 * @author K. Benedyczak
 */
public interface IResolver
{
	SecurityContext resolve(SecurityTokens input) throws IdUnresolvedException, UVOSException;
}
