/*
 * Copyright (c) 2012 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE.txt file for licensing information.
 */
package pl.edu.icm.unicore.uvos.util;

import java.util.concurrent.ScheduledThreadPoolExecutor;
import java.util.concurrent.ThreadFactory;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;


/**
 * Provides shared executor for scheduling re-occurring tasks.
 * @author K. Benedyczak
 */
public class ThreadScheduler
{
	private ScheduledThreadPoolExecutor scheduler;
	
	public ThreadScheduler() 
	{
		scheduler=new ScheduledThreadPoolExecutor(3);
		scheduler.setKeepAliveTime(3000, TimeUnit.MILLISECONDS);
		scheduler.setThreadFactory(new ThreadFactory(){
        			final AtomicInteger threadNumber = new AtomicInteger(1);
		        	public Thread newThread(Runnable r) {
		        		Thread t = new Thread(r);
		        		t.setName("uvos-scheduled-"+threadNumber.getAndIncrement());
		        		return t;
		        	}
				});
	}
	
	public ScheduledThreadPoolExecutor getScheduledExecutor() 
	{
		return scheduler;
	}
}
