/*
 * Copyright (c) 2012 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE.txt file for licensing information.
 */
package pl.edu.icm.unicore.uvos.server;

import java.util.Calendar;
import java.util.Date;

import org.junit.Assert;
import org.junit.Test;

import pl.edu.icm.unicore.uvos.registration.UVOSEMIRClient;
import pl.edu.icm.unicore.uvos.util.GLUEInfoProvider;

import eu.emi.emir.client.EMIRClient;

public class EMIRTest
{
	//surefire
	@Test
	public void foo() {}
	
	//the test can be enabled only when EMIR daemon is running
	//@Test
	public void getEndpointDescription() throws Exception
	{
		EMIRClient client = new EMIRClient("http://localhost:54321");
		GLUEInfoProvider infoProvider = new GLUEInfoProvider("http://baseUrl");
		UVOSEMIRClient clientUtil = new UVOSEMIRClient(client, infoProvider);
		
		Date ret = clientUtil.readd();
		checkDate(ret);
		
		ret = clientUtil.readd();
		checkDate(ret);
	}
	
	private void checkDate(Date ret)
	{
		System.out.println(ret);
		Calendar now = Calendar.getInstance();
		now.add(Calendar.MINUTE, 6);
		Calendar expire = Calendar.getInstance();
		expire.setTime(ret);
		Assert.assertTrue(expire.after(now));
	}
}
