/*
 * Copyright (c) 2011 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on 11-02-2011
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */
package pl.edu.icm.unicore.uvos.server;

import junit.framework.Assert;

import org.junit.Test;

import eu.unicore.bugsreporter.annotation.RegressionTest;
import pl.edu.icm.unicore.uvos.db.InitDB;
import pl.edu.icm.unicore.uvos.server.VOServer;

public class StartupTest
{
	/**
	 * Starts server without web applications in the same way as it is started 
	 * from the script.
	 */
	@RegressionTest(url="http://sourceforge.net/tracker/index.php?func=detail&aid=3163919&group_id=102081&atid=633902")
	@Test
	public void testStart()
	{
		final String CONFIG_FILE = "src/test/resources/uvosServer.conf";
		try
		{
			InitDB.main(new String[] {CONFIG_FILE, "-b"});
			VOServer server = VOServer.initializeDI(new String[]{CONFIG_FILE});
			server.shutdown();
		} catch (Exception e) 
		{
			e.printStackTrace();
			Assert.fail(e.toString());
		}
	}
}
