/*
 * Copyright (c) 2007, 2008 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on Sep 20, 2007
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */

package pl.edu.icm.unicore.uvos.tests.functional;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.junit.Test;

import static junit.framework.Assert.*;

import pl.edu.icm.unicore.uvos.api.Attribute;
import pl.edu.icm.unicore.uvos.api.PermissionDesignator;
import pl.edu.icm.unicore.uvos.api.Permissions;

/**
 * Performs functional tests. Assumptions:
 * Server is up and running and DB is empty
 * @author K. Benedyczak
 */
public class AuthzFunctionalTest extends AbstractTestBase
{
	@Test
	public void testAll()
	{
		try
		{
			createTestGI();
			tstPolicyModification();
			cleanTestGI();
		} catch (Exception e)
		{
			e.printStackTrace();
			fail("Exception: " + e.getMessage());
		}
	}
	
	private void tstPolicyModification() throws Exception
	{
		List<String> vals = new ArrayList<String>();
		vals.add("a");
		vals.add("a");
		Attribute attr = new Attribute("urn:authz:intervo:vo", vals, null);
		voAuthz.modifyPermissions(gZ, new PermissionDesignator(attr), Permissions.ALL_P);
		
		voMan.purgeHistoricalData(new Date());
	}
}














