/*
 * Copyright (c) 2010 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on 2010-07-04
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */

package pl.edu.icm.unicore.uvos.tests.functional;

import static junit.framework.Assert.*;

import org.junit.Test;

import pl.edu.icm.unicore.uvos.server.IssuerIdentityProviderImpl;
import pl.edu.icm.unicore.uvos.util.UVOSServerProperties;

/**
 * Tests {@link IssuerIdentityProviderImpl} class.
 * @author golbi
 */
public class CryptoDataProviderTest
{
	@Test
	public void test1()
	{
		try
		{
			UVOSServerProperties cnf = new UVOSServerProperties("src/test/resources/uvosServer-wrongAlias.conf");
			new IssuerIdentityProviderImpl(cnf);
		} catch (Exception e)
		{
			assertTrue("Wrong exception received", 
				e.getMessage().contains("Key alias"));
			return;
		}
		fail("Managed to init CryptoDataProviderImpl with non existing alias.");
	}

	@Test
	public void test2()
	{
		try
		{
			UVOSServerProperties cnf = new UVOSServerProperties("src/test/resources/uvosServer-wrongAlias2.conf");
			new IssuerIdentityProviderImpl(cnf);
		} catch (Exception e)
		{
			assertTrue("Wrong exception received: " + e,
				e.getMessage().contains("certificate entry"));
			return;
		}
		fail("Managed to init CryptoDataProviderImpl with certificate alias as a key alias.");
	}
	
	@Test
	public void testOK()
	{
		try
		{
			UVOSServerProperties cnf = new UVOSServerProperties("src/test/resources/uvosServer.conf");
			new IssuerIdentityProviderImpl(cnf);
		} catch (Exception e)
		{
			fail("Got error on good data");
			return;
		}
	}
	
}
