/*
 * Copyright (c) 2011 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on 03-09-2011
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */
package pl.edu.icm.unicore.uvos.tests.functional;

import org.junit.Test;
import static org.junit.Assert.*;

import pl.edu.icm.unicore.uvos.server.WSGLUEInfoProviderImpl;
import pl.edu.icm.unicore.uvos.util.GLUEInfoProvider;
import xmlbeans.pl.edu.icm.uvos.cisprovider.GetServiceInfoRequestDocument;
import xmlbeans.pl.edu.icm.uvos.cisprovider.GetServiceInfoResponseDocument;
import xmlbeans.pl.edu.icm.uvos.glue2.EndpointT;
import xmlbeans.pl.edu.icm.uvos.glue2.ServiceT;

public class GLUETest
{
	@Test
	public void test() throws Exception
	{
		WSGLUEInfoProviderImpl impl = new WSGLUEInfoProviderImpl(
				new GLUEInfoProvider("http://localhost/services/UVOS"));
		GetServiceInfoRequestDocument req = GetServiceInfoRequestDocument.Factory.newInstance();
		GetServiceInfoResponseDocument respDoc = impl.getServiceInfo(req);
		//System.out.println(respDoc.xmlText(new XmlOptions().setSavePrettyPrint()));
		ServiceT serviceDesc = respDoc.getGetServiceInfoResponse().getServiceArray(0);
		assertEquals(1, serviceDesc.getEndpointArray().length);
		EndpointT endpoint = serviceDesc.getEndpointArray(0);
		assertTrue(endpoint.getImplementationVersion() != null);
	}
}
