/*
 * Copyright (c) 2007, 2008 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on Sep 20, 2007
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */

package pl.edu.icm.unicore.uvos.tests.functional;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;

import static junit.framework.Assert.*;

import pl.edu.icm.unicore.uvos.api.Attribute;
import pl.edu.icm.unicore.uvos.api.Element;
import pl.edu.icm.unicore.uvos.util.UVOSServerProperties;


/**
 * Tests if NULL -> -1 and vice versa is working
 * @author K. Benedyczak
 */
public class IntNullMappingTest extends AbstractTestBase
{
	private String atPrefix;
	private byte binVal[] = new byte[256];
	
	@Test
	public void testAll()
	{
		for (int i=0; i<255; i++)
			binVal[i] = (byte)(i+1);
		try
		{
			createTestGI();
			atPrefix = "test:attribute";
			tstAttrs();
			cleanTestGI();
		} catch (Exception e)
		{
			e.printStackTrace();
			fail("Exception: " + e.getMessage());
		}
	}

	private void tstAttrs() throws Exception
	{
		config.setProperty(UVOSServerProperties.GENERATE_ATTRIBUTES_FROM_DN, "false");
		voMan.addToGroup(idA1, gC);
		List<String> vals1 = new ArrayList<String>();
		vals1.add("<>~`!@#$%^&*()<!-- -->,<.>/?';:[{]}\\=-");
		Attribute attr3 = new Attribute(atPrefix + ":attr3", vals1, null);
		Element elGc = new Element(gC, null);
		Element elIa2 = new Element(null, idA2);
		Element elidAingC = new Element(gC, idA2);
		
		List<Attribute> al1;
		
		
		voMan.setAttribute(elIa2, attr3, false);
		//al1 = voQuery.getAttributes(new Element(gA, idA2), null, true, false, false);
		
		voMan.removeAttribute(elIa2, attr3.getName());
		al1 = voQuery.getAttributes(elidAingC, null, true, false, false);
		if (al1.size() != 0)
			fail("Wrong number attrs received (removal (1)) " + 
					al1.size() + " " + al1.get(0));
		al1 = voQuery.getAttributes(elGc, null, true, false, false);
		if (al1.size() != 0)
			fail("Wrong number attrs received (removal (2)) " + 
					al1.size());
		al1 = voQuery.getAttributes(elIa2, null, true, false, false);
		if (al1.size() != 0)
			fail("Wrong number attrs received (removal (3)) " + 
					al1.size());
	}
}